// This file is part of the uSTL library, an STL implementation.
//
// Copyright (c) 2005 by Mike Sharov <msharov@users.sourceforge.net>
// This file is free software, distributed under the MIT License.
//
// This is gcc's definition of type_info necessary for autogenerated
// type information for exception classes.

#pragma once
#if WITHOUT_LIBSTDCPP
#include "uexception.h"

namespace __cxxabiv1 { class __class_type_info; }

namespace std {
class type_info {
public:
    inline virtual	~type_info (void)			{ }
    inline const char*	name (void) const			{ return __name[0] == '*' ? __name + 1 : __name; }
    inline bool		before (const type_info& v) const	{ return __name < v.__name; }
    inline bool		operator==(const type_info& v) const	{ return __name == v.__name; }
    inline bool		operator!=(const type_info& v) const	{ return !operator==(v); }
    virtual bool	__is_pointer_p (void) const;
    virtual bool	__is_function_p (void) const;
    virtual bool	__do_catch (const type_info* __thr_type, void** __thr_obj, unsigned __outer) const;
    virtual bool	__do_upcast (const __cxxabiv1::__class_type_info* __target, void** __obj_ptr) const;
    explicit inline	type_info (const char* newname)		: __name(newname) { }
#if HAVE_CPP11
    type_info&		operator= (const type_info&) = delete;
			type_info (const type_info&) = delete;
#else
private:
    inline type_info&	operator= (const type_info&)	{ return *this; }
    inline		type_info (const type_info& t)	:__name(t.__name) { }
#endif
protected:
    const char*		__name;
};
} // namespace std

#endif	// WITHOUT_LIBSTDCPP
